#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <math.h>
#include "triccaboard.c"
#include "triccagantry.c"
#include "wellplateprotocols.c"
#include "gantrycontroller.c"
#include "servo.c"
#define SLEEP_TIME_MS	1000
#define M_PI    3.14159265358979323846


int main(void)
{
    gpio_setup();

    homeServo(2, 15, 2); // Home the servo to 15 degrees

    // Define an array of angles
    int angles[] = {169, 15, 90, 169, 15, 80, 15, 169}; // Add more angles as needed
    int num_angles = sizeof(angles) / sizeof(angles[0]);
    int duration_ms = 700;

    executeAngleSequence(angles, num_angles, duration_ms, 2, 2);

    return 0;
}
