#include "triccaboard.h"
#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/drivers/i2c.h>


int gpio_setup()
{
	int ret;

	if (!device_is_ready(ex1.port)) {
		return -1;
	}
	if (!device_is_ready(ex2.port)) {
		return -1;
	}
	if (!device_is_ready(ex3.port)) {
		return -1;
	}
	if (!device_is_ready(ex4.port)) {
		return -1;
	}
	if (!device_is_ready(ex5.port)) {
		return -1;
	}
	if (!device_is_ready(ex6.port)) {
		return -1;
	}
	if (!device_is_ready(ex7.port)) {
		return -1;
	}
	if (!device_is_ready(ex8.port)) {
		return -1;
	}
	if (!device_is_ready(ex9.port)) {
		return -1;
	}
	if (!device_is_ready(ex10.port)) {
		return -1;
	}
	if (!device_is_ready(ex11.port)) {
		return -1;
	}
	if (!device_is_ready(ex12.port)) {
		return -1;
	}
	if (!device_is_ready(enl.port)) {
		return -1;
	}
	if (!device_is_ready(mux0.port)) {
		return -1;
	}
	if (!device_is_ready(mux1.port)) {
		return -1;
	}
	if (!device_is_ready(mux2.port)) {
		return -1;
	}
	if (!device_is_ready(smux0.port)) {
		return -1;
	}
	if (!device_is_ready(smux1.port)) {
		return -1;
	}
	if (!device_is_ready(smux2.port)) {
		return -1;
	}
	if (!device_is_ready(smux3.port)) {
		return -1;
	}
	if (!device_is_ready(ens.port)) {
		return -1;
	}
	if (!device_is_ready(clks.port)) {
		return -1;
	}
	if (!device_is_ready(dirs.port)) {
		return -1;
	}
	if (!device_is_ready(steps.port)) {
		return -1;
	}
	if (!device_is_ready(mmux0.port)) {
		return -1;
	}
	if (!device_is_ready(mmux1.port)) {
		return -1;
	}
	if (!device_is_ready(mmux2.port)) {
		return -1;
	}
	if (!device_is_ready(clkm.port)) {
		return -1;
	}
	if (!device_is_ready(lmux0.port)) {
		return -1;
	}
	if (!device_is_ready(lmux1.port)) {
		return -1;
	}
	if (!device_is_ready(lmux2.port)) {
		return -1;
	}
	if (!device_is_ready(lmux3.port)) {
		return -1;
	}
	if (!device_is_ready(lmt.port)) {
		return -1;
	}
	if (!device_is_ready(miscm.port)) {
		return -1;
	}
	if (!device_is_ready(serv0_dev.port)) {
		return -1;
	}
	if (!device_is_ready(serv1_dev.port)) {
		return -1;
	}
	if (!device_is_ready(serv2_dev.port)) {
		return -1;
	}
	if (!device_is_ready(serv3_dev.port)) {
		return -1;
	}
	ret = gpio_pin_configure_dt(&ex1, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex2, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex3, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex4, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex5, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex6, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex7, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex8, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex9, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex10, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex11, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ex12, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&enl, GPIO_OUTPUT_HIGH);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mux0, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mux1, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mux2, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&smux0, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&smux1, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&smux2, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&smux3, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&ens, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&clks, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&dirs, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&steps, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mmux0, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mmux1, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&mmux2, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&clkm, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&miscm, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&lmux0, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&lmux1, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&lmux2, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&lmux3, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&lmt, GPIO_INPUT);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&serv0_dev, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&serv1_dev, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&serv2_dev, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	ret = gpio_pin_configure_dt(&serv3_dev, GPIO_OUTPUT_LOW);
	if (ret < 0) {
		return ret;
	}
	return 1;
}

void mux_select(int num, enum Mux_type type)
{
	// Turn num into a bit representation
    int bit0 = (num & 1) == 1;
    int bit1 = (num & 2) == 2;
    int bit2 = (num & 4) == 4;
    int bit3 = (num & 8) == 8;

    switch (type) {
        case LIMIT:
            gpio_pin_set_dt(&lmux0, bit0);
            gpio_pin_set_dt(&lmux1, bit1);
            gpio_pin_set_dt(&lmux2, bit2);
            gpio_pin_set_dt(&lmux3, bit3);
            break;
        case MOTOR:
            gpio_pin_set_dt(&smux0, bit0);
            gpio_pin_set_dt(&smux1, bit1);
            gpio_pin_set_dt(&smux2, bit2);
            gpio_pin_set_dt(&smux3, bit3);
            break;
        case MISC:
            gpio_pin_set_dt(&mmux0, bit0);
            gpio_pin_set_dt(&mmux1, bit1);
            gpio_pin_set_dt(&mmux2, bit2);
            break;
        case LED:
            gpio_pin_set_dt(&mux0, bit0);
            gpio_pin_set_dt(&mux1, bit1);
            gpio_pin_set_dt(&mux2, bit2);
    }
}

void motor_switch(int motor, int en)
{
    enum Mux_type type = MOTOR;
    mux_select(motor, type);
	gpio_pin_set_dt(&ens, en);
	gpio_pin_toggle_dt(&clks);
	gpio_pin_toggle_dt(&clks);
}

void motor_setup()
{
    for (int i=0; i < NUM_MOTORS; i++) {
        motor_switch(i, 1);
    }
}

void motor_step(int motor, double numSteps, int dir, double delay_us)
{
    enum Mux_type type = MOTOR;
	mux_select(motor, type);
    gpio_pin_set_dt(&dirs, dir);
	for (double i=0.0; i<numSteps; i++) {
		gpio_pin_toggle_dt(&steps);
    	k_usleep(delay_us);
	}
}

void led_switch(int pos, int state)
{
	enum Mux_type type = LED;
	mux_select(pos, type);
	gpio_pin_set_dt(&enl, state);
}

int i2c_setup()
{
    int ret = 0;
    // Check I2C
    if (!device_is_ready(bh1749_dev.bus) || !device_is_ready(tca9548_dev.bus)) {
    	printk("I2C busses not ready!\n\r");
        return -1;
    }

    // Setup i2c mux by setting default sensor position to 0
    //   - Each bit in the byte represents a position. e.g. 0000 0001 enables sensor position 0
    uint8_t posbuf[2] = {TCA9548_ADDR, 0x01};
    ret = i2c_write_dt(&tca9548_dev, &posbuf[0], sizeof(posbuf));
    if (ret != 0) {
        printk("Failed to set sensor mux to position 0.\n\r");
        return ret;
    }

    // Setup sensor by setting integration time to 240ms, gain to 32x, and enable RGB measurements
    uint8_t settingsbuf[3] = {BH1749_ADDR_MODE_CTRL1, BH1749_MAX_GAIN_MAX_INT, BH1749_MODE_CTRL2_RGB_EN_ENABLE};
    ret = i2c_write_dt(&bh1749_dev, &settingsbuf[0], sizeof(settingsbuf));
    if (ret != 0){
        printk("Failed to set sensor settings.\n\r");
        return ret;
    }
    return ret;
}

int button_status(enum Buttons btn)
{
	enum Mux_type type = LIMIT;
	mux_select(btn, type);       // Enum to int abuse
	return gpio_pin_get_dt(&lmt);
}

void misc_select(int pos, int state)
{
	mux_select(pos, MISC);
	gpio_pin_set_dt(&miscm, state);
	gpio_pin_toggle_dt(&clkm);
	gpio_pin_toggle_dt(&clkm);
}

void mult_motors_step(int* motors, int numMotors, double numSteps, int dir, double delay_us)
{
	for (double i=0.0; i<numSteps; i++) {
		for (int j=0; j < numMotors; j++) {
			motor_step(motors[j], 1, dir, delay_us);
		}
	}
}